<?
require_once("config.php");
function print_version()
{
}

if (function_exists("bcadd"))
{
    function sqlAdd($left, $right)
    {
        return bcadd($left, $right,0);
    }
    function sqlSubtract($left, $right)
    {
        return bcsub($left, $right,0);
    }
    function sqlMultiply($left, $right)
    {
        return bcmul($left, $right,0);
    }
    function sqlDivide($left, $right)
    {
        return bcdiv($left, $right,0);
    }
}
else // BC vs SQL math
{

// Uses the mysql database connection to perform string math. :)
// Used by byte counting functions
// No error handling as we assume nothing can go wrong. :|
function sqlAdd($left, $right)
{
    $query = 'SELECT '.$left.'+'.$right;
    $results = mysql_query($query) or showError("Database error.");
    return mysql_result($results,0,0);
}

// Ditto
function sqlSubtract($left, $right)
{
    $query = 'SELECT '.$left.'-'.$right;
    $results = mysql_query($query) or showError("Database error");
    return mysql_result($results,0,0);
}

function sqlDivide($left, $right)
{
    $query = 'SELECT '.$left.'/'.$right;
    $results = mysql_query($query) or showError("Database error");
    return mysql_result($results,0,0);
}

function sqlMultiply($left, $right)
{
    $query = 'SELECT '.$left.'*'.$right;
    $results = mysql_query($query) or showError("Database error");
    return mysql_result($results,0,0);
}


} // End of BC vs SQL

// Runs a query with no regard for the result
function quickQuery($query)
{
    $results = @mysql_query($query);
    if (!is_bool($results))
        mysql_free_result($results);
    else
        return $results;
    return true;
}

function hex2bin ($input, $assume_safe=true)
{
    if ($assume_safe !== true && ! ((strlen($input) % 2) === 0 || preg_match ('/^[0-9a-f]+$/i', $input)))
        return "";
    return pack('H*', $input );
}

// Reports an error to the client in $message.
// Any other output will confuse the client, so please don't do that.
function showError($message, $log=false)
{
  if ($log)
      error_log("PHPBTTracker: Sent error ($message)");
  echo "d14:failure reason".strlen($message).":$message"."e";
  exit(0);
}



// Used by newtorrents.php and the dynamic_torrents setting
// Returns true/false, depending on if there were errors.
function makeTorrent($hash, $tolerate = false)
{
    if (strlen($hash) != 40)
        showError("makeTorrent: Received an invalid hash");
    $result = true;
    // old
    //$query = "CREATE TABLE x$hash (peer_id char(40) NOT NULL default '', bytes bigint NOT NULL default 0, ip char(50) NOT NULL default 'error.x', port smallint UNSIGNED NOT NULL default \"0\", status enum('leecher','seeder') NOT NULL, lastupdate int unsigned NOT NULL default 0, sequence int unsigned AUTO_INCREMENT NOT NULL, natuser enum('N', 'Y') not null default 'N', primary key(sequence), unique(peer_id))";
    // new with domain suffix and client
    $query = "SELECT * FROM summary";

    if (!@mysql_query($query))
        $result = false;

    if (!$result && !$tolerate)
        return false;
    if (isset($GLOBALS["peercaching"]) && $GLOBALS["peercaching"])
    {
        $query = "SELECT * FROM summary";
        mysql_query($query);
    }
    $query = "INSERT INTO summary set info_hash=\"".$hash."\", lastSpeedCycle=UNIX_TIMESTAMP()";
    if (!@mysql_query($query))
        $result = false;
    return $result;
}

// Returns true if the torrent exists.
// Currently checks by locating the row in "summary"
// Always returns true if $dynamic_torrents=="1" unless an error occured
function verifyTorrent($hash)
{
    $query = "SELECT COUNT(*) FROM summary where info_hash=\"$hash\"";
    $results = mysql_query($query);

    $res = mysql_result($results,0,0);

    if ($res == 1)
        return true;

    if ($GLOBALS["dynamic_torrents"])
        return makeTorrent($hash);

    return false;
}

function verifyHash($input)
{
    if (strlen($input) === 40 && preg_match('/^[0-9a-f]+$/', $input))
        return true;
    else
        return false;
}




// Returns info on one peer
function getPeerInfo($user, $hash)
{
    // If "trackerid" is set, let's try that
    if (isset($GLOBALS["trackerid"]))
    {
        $query = "SELECT peer_id,bytes,ip,port,status,lastupdate,sequence FROM x$hash WHERE sequence=${GLOBALS["trackerid"]}";
        $results = mysql_query($query) or showError("Tracker error: invalid torrent");
        $data = mysql_fetch_assoc($results);
        if (!$data || $data["peer_id"] != $user)
        {
            // Damn, but don't crash just yet.
            $query = "SELECT peer_id,bytes,ip,port,status,lastupdate,sequence from x$hash where peer_id=\"$user\"";
            $results = mysql_query($query) or showError("Tracker error: invalid torrent");
            $data = mysql_fetch_assoc($results);
            $GLOBALS["trackerid"] = $data["sequence"];
        }
    }
    else
    {
        $query = "SELECT peer_id,bytes,ip,port,status,lastupdate,sequence from x$hash where peer_id=\"$user\"";
        $results = mysql_query($query) or showError("Tracker error: invalid torrent");
        $data = mysql_fetch_assoc($results);
        $GLOBALS["trackerid"] = $data["sequence"];

    }

    if (!($data))
        return false;

    return $data;
}

// Slight redesign of loadPeers
function getRandomPeers($hash, $where="")
{
    // Don't want to send a bad "num peers" for new seeds

    if ($GLOBALS["NAT"])
        $results = mysql_query("SELECT COUNT(*) FROM x$hash WHERE natuser = 'N'");
    else
        $results = mysql_query("SELECT COUNT(*) FROM x$hash");

    $peercount = mysql_result($results, 0,0);

    // ORDER BY RAND() is expensive. Don't do it when the load gets too high
    if ($peercount < 500)
        $query = "SELECT ".((isset($_GET["no_peer_id"]) && $_GET["no_peer_id"] == 1) ? "" : "peer_id,")."ip, port, status FROM x$hash ".$where." ORDER BY RAND() LIMIT ${GLOBALS['maxpeers']}";
    else
        $query = "SELECT ".((isset($_GET["no_peer_id"]) && $_GET["no_peer_id"] == 1) ? "" : "peer_id,")."ip, port, status FROM x$hash LIMIT ".@mt_rand(0, $peercount - $GLOBALS["maxpeers"]).", ${GLOBALS['maxpeers']}";

    $results = mysql_query($query);
    if (!$results)
        return false;

    $peerno = 0;
    while ($return[] = mysql_fetch_assoc($results))
        $peerno++;

    array_pop ($return);
    mysql_free_result($results);
    $return['size'] = $peerno;

    return $return;
}

// Deletes a peer from the system and performs all cleaning up
//
//  $assumepeer contains the result of getPeerInfo, or false
//  if we should grab it ourselves.
function killPeer($userid, $hash, $left, $assumepeer = false)
{
    if (!$assumepeer)
    {
        $peer = getPeerInfo($userid, $hash);
        if (!$peer)
            return;
        if ($left != $peer["bytes"])
            $bytes = sqlSubtract($peer["bytes"], $left);
        else
            $bytes = 0;
    }
    else
    {
        $bytes = 0;
        $peer = $assumepeer;
    }

    quickQuery("DELETE FROM x$hash WHERE peer_id=\"$userid\"");
    if (mysql_affected_rows() == 1)
    {
        if ($GLOBALS["peercaching"])
            quickQuery("DELETE FROM y$hash WHERE sequence=" . $peer["sequence"]);
        if ($peer["status"] == "leecher")
            summaryAdd("leechers", -1);
        else
            summaryAdd("seeds", -1);
        if ($GLOBALS["countbytes"] && ((float)$bytes) > 0)
            summaryAdd("dlbytes",$bytes);
        if ($peer["bytes"] != 0 && $left == 0)
            summaryAdd("finished", 1);
    }
}

// Updates the peer user's info.
// Currently it does absolutely nothing. lastupdate is set in collectBytes
// as well.
function updatePeer($peerid, $hash)
{
}


// Transfers bytes from "left" to "dlbytes" when a peer reports in.
function collectBytes($peer, $hash, $left, $downloaded=0, $uploaded=0, $pid="")
{
    $peerid=$peer["peer_id"];

    if (!$GLOBALS["countbytes"])
    {
        quickQuery("UPDATE x$hash SET lastupdate=UNIX_TIMESTAMP(), downloaded=$downloaded, uploaded=$uploaded, pid=\"$pid\" where " . (isset($GLOBALS["trackerid"]) ? "sequence=\"${GLOBALS["trackerid"]}\"" : "peer_id=\"$peerid\""));
        return;
    }
    $diff = sqlSubtract($peer["bytes"], $left);
    quickQuery("UPDATE x$hash set " . (($diff != 0) ? "bytes=\"$left\"," : ""). " lastupdate=UNIX_TIMESTAMP(), downloaded=$downloaded, uploaded=$uploaded, pid=\"$pid\" where " . (isset($GLOBALS["trackerid"]) ? "sequence=\"${GLOBALS["trackerid"]}\"" : "peer_id=\"$peerid\""));

    // Anti-negative clause
    if (((float)$diff) > 0)
        summaryAdd("dlbytes", $diff);
}

// Transmits the actual data to the peer. No other output is permitted if
// this function is called, as that would break BEncoding.
// I don't use the bencode library, so watch out! If you add data,
// rules such as dictionary sorting are enforced by the remote side.
function sendPeerList($peers)
{
    echo "d";
    echo "8:intervali".$GLOBALS["report_interval"]."e";
    if (isset($GLOBALS["min_interval"]))
        echo "12:min intervali".$GLOBALS["min_interval"]."e";
    echo "5:peers";
    $size=$peers["size"];
    if (isset($_GET["compact"]) && $_GET["compact"] == '1')
    {
        $p = '';
        for ($i=0; $i < $size; $i++)
            $p .= str_pad(pack("Nn", ip2long($peers[$i]['ip']), $peers[$i]['port']), 6); //$p .= pack("Nn", ip2long($peers[$i]['ip']), $peers[$i]['port']);
        echo strlen($p).':'.$p;
    }
    else // no_peer_id or no feature supported
    {
        echo 'l';
        for ($i=0; $i < $size; $i++)
        {
            echo "d2:ip".strlen($peers[$i]["ip"]).":".$peers[$i]["ip"];
            if (isset($peers[$i]["peer_id"]))
                echo "7:peer id20:".hex2bin($peers[$i]["peer_id"]);
            echo "4:porti".$peers[$i]["port"]."ee";
        }
        echo "e";
    }
    if (isset($GLOBALS["trackerid"]))
    {
        // Now it gets annoying. trackerid is a string
        echo "10:tracker id".strlen($GLOBALS["trackerid"]).":".$GLOBALS["trackerid"];
    }

    echo "e";
}


// Faster pass-through version of getRandompeers => sendPeerList
// It's the only way to use cache tables. In fact, it only uses it.
function sendRandomPeers($info_hash)
{
    $result = mysql_query("SELECT COUNT(*) FROM y$info_hash");
    $count = mysql_result($result, 0, 0);

    if (isset($_GET["compact"]) && $_GET["compact"] == '1')
        $column = "compact";
    else if (isset($_GET["no_peer_id"]) && $_GET["no_peer_id"] == '1')
        $column = "without_peerid";
    else
        $column = "with_peerid";

    if ($count < $GLOBALS["maxpeers"])
        $query = "SELECT $column FROM y$info_hash";
    else if ($count > 500)
    {
        do
        {
            $rand1 = mt_rand(0, $count-$GLOBALS["maxpeers"]);
            $rand2 = mt_rand(0, $count-$GLOBALS["maxpeers"]);
        } while (abs($rand1 - $rand2) < $GLOBALS["maxpeers"]/2);
        $query = "(SELECT $column FROM y$info_hash LIMIT $rand1, ".($GLOBALS["maxpeers"]/2). ") UNION (SELECT $column FROM y$info_hash LIMIT $rand2, ".($GLOBALS["maxpeers"]/2). ")";
    }
    else
        $query = "SELECT $column FROM y$info_hash ORDER BY RAND() LIMIT ".$GLOBALS["maxpeers"];



    echo "d";
    echo "8:intervali".$GLOBALS["report_interval"]."e";
    if (isset($GLOBALS["min_interval"]))
        echo "12:min intervali".$GLOBALS["min_interval"]."e";
    echo "5:peers";

    $result = mysql_query($query);
    if ($column == "compact")
    {
        echo (mysql_num_rows($result) * 6) . ":";
        while ($row = mysql_fetch_row($result))
            echo str_pad($row[0], 6); //echo $row[0];
    }
    else
    {
        echo "l";
        while ($row = mysql_fetch_row($result))
            echo "d".$row[0]."e";
        echo "e";
    }
    if (isset($GLOBALS["trackerid"]))
        echo "10:tracker id".strlen($GLOBALS["trackerid"]).":".$GLOBALS["trackerid"];
    echo "e";
}


// Returns a $peers array of all peers that have timed out (2* report interval seems fair
// for any reasonable report interval (900 or larger))
function loadLostPeers($hash, $timeout)
{
    $results = mysql_query("SELECT peer_id,bytes,ip,port,status,lastupdate,sequence from x$hash where lastupdate < (UNIX_TIMESTAMP() - 2 * $timeout)");
    echo "SELECT peer_id,bytes,ip,port,status,lastupdate,sequence from x$hash where lastupdate < (UNIX_TIMESTAMP() - 2 * $timeout)<br>";
    $peerno = 0;
    if (!$results)
        return false;

    while ($return[] = mysql_fetch_assoc($results))
        $peerno++;
    array_pop($return);
    $return["size"] = $peerno;
    mysql_free_result($results);
    return $return;
}

function trashCollector($hash, $timeout)
{
    if (isset($GLOBALS["trackerid"]))
        unset($GLOBALS["trackerid"]);

    if (!Lock($hash))
        return;

    $results = mysql_query("SELECT lastcycle FROM summary WHERE info_hash='$hash'");
    $lastcheck = (mysql_fetch_row($results));

    // Check once every re-announce cycle
    if (($lastcheck[0] + $timeout) < time())
    {
        $peers = loadLostPeers($hash, $timeout);
        for ($i=0; $i < $peers["size"]; $i++)
            killPeer($peers[$i]["peer_id"], $hash, $peers[$i]["bytes"]);
        summaryAdd("lastcycle", "UNIX_TIMESTAMP()", true);
    }
    Unlock($hash);
}

// Attempts to aquire a lock by name.
// Returns true on success, false on failure
function Lock($hash, $time = 0)
{
    $results = mysql_query("SELECT GET_LOCK('$hash', $time)");
    $string = mysql_fetch_row($results);
    if (strcmp($string[0], "1") == 0)
        return true;
    return false;

}

// Releases a lock. Ignores errors.
function Unlock($hash)
{
    quickQuery("SELECT RELEASE_LOCK('$hash')");
}

// Returns true if the lock is available
function isFreeLock($lock)
{
    if (Lock($lock, 0))
    {
        Unlock($lock);
        return true;
    }
    return false;
}


/* Returns true if the user is firewalled, NAT'd, or whatever.
 * The original tracker had its --nat_check parameter, so
 * here is my version.
 *
 * This code has proven itself to be sufficiently correct,
 * but will consume system resources when a lot of httpd processes
 * are lingering around trying to connect to remote hosts.
 * Consider disabling it under higher loads.
 */
function isFireWalled($hash, $peerid, $ip, $port)
{

    // NAT checking off?
    if (!$GLOBALS["NAT"])
        return false;

    $protocol_name = 'BitTorrent protocol';
    $theError = "";
    // Hoping 10 seconds will be enough
    $fd = fsockopen($ip, $port, $errno, $theError, 10);
    if (!$fd)
        return true;

    stream_set_timeout($fd, 5, 0);
    fwrite($fd, chr(strlen($protocol_name)).$protocol_name.hex2bin("0000000000000000").
        hex2bin($hash));

    $data = fread($fd, strlen($protocol_name)+1+20+20+8); // ideally...

    fclose($fd);
    $offset = 0;

    // First byte: strlen($protocol_name), then the protocol string itself
    if (ord($data[$offset]) != strlen($protocol_name))
        return true;

    $offset++;
    if (substr($data, $offset, strlen($protocol_name)) != $protocol_name)
        return true;

    $offset += strlen($protocol_name);
    // 8 bytes reserved, ignore
    $offset += 8;

    // Download ID (hash)
    if (substr($data, $offset, 20) != hex2bin($hash))
        return true;

    $offset+=20;

    // Peer ID
    if (substr($data, $offset, 20) != hex2bin($peerid))
        return true;


    return false;
}


// It's cruel, but if people abuse my tracker, I just might do it.
// It pretends to accept the torrent, and reports that you are the
// only person connected.
function evilReject($ip, $peer_id, $port)
{

    // For those of you who are feeling evil, comment out this line.
    showError("Torrent is not authorized for use on this tracker.");

    $peers[0]["peer_id"] = $peer_id;
    $peers[0]["ip"] = $ip;
    $peers[0]["port"] = $port;
    $peers["size"] = 1;
    $GLOBALS["report_interval"] = 86400;
    $GLOBALS["min_interval"] = 86000;
    sendPeerList($peers);
    exit(0);
}


function runSpeed($info_hash, $delta)
{
        //stick in our latest data before we calc it out
        quickQuery("INSERT IGNORE INTO timestamps (info_hash, bytes, delta, sequence) SELECT '$info_hash' AS info_hash, dlbytes, UNIX_TIMESTAMP() - lastSpeedCycle, NULL FROM summary WHERE info_hash=\"$info_hash\"");

        // mysql blows sometimes so we have to read the data into php before updating it
        $results = mysql_query('SELECT (MAX(bytes)-MIN(bytes))/SUM(delta), COUNT(*), MIN(sequence) FROM timestamps WHERE info_hash="'.$info_hash.'"' );
        $data = mysql_fetch_row($results);

        summaryAdd("speed", $data[0], true);
        summaryAdd("lastSpeedCycle", "UNIX_TIMESTAMP()", true);

        // if we have more than 20 drop the rest
        if ($data[1] == 21)
            quickQuery("DELETE FROM timestamps WHERE info_hash=\"$info_hash\" AND sequence=${data[2]}");
        else if ($data[1] > 21)
        // This query requires MySQL 4.0.x, but should rarely be used.
        quickQuery ('DELETE FROM timestamps WHERE info_hash="'.$info_hash.'" ORDER BY sequence LIMIT '.($data['1'] - 20));
}

// Schedules an update to the summary table. It gets so much traffic
// that we do all our changes at once.
// When called, the column $column for the current info_hash is incremented
// by $value, or set to exactly $value if $abs is true.
function summaryAdd($column, $value, $abs = false)
{
    if (isset($GLOBALS["summaryupdate"][$column]))
    {
        if (!$abs)
            $GLOBALS["summaryupdate"][$column][0] += $value;
        else
            showError("Tracker bug calling summaryAdd");
    }
    else
    {
        $GLOBALS["summaryupdate"][$column][0] = $value;
        $GLOBALS["summaryupdate"][$column][1] = $abs;
    }
}




// Even if you're missing PHP 4.3.0, the MHASH extension might be of use.
// Someone was kind enought to email this code snippit in.
if (function_exists('mhash') && (!function_exists('sha1')) &&
defined('MHASH_SHA1'))
{
    function sha1($str)
    {
        return bin2hex(mhash(MHASH_SHA1,$str));
    }
}

// begin of function added from original

function unesc($x) {
    if (get_magic_quotes_gpc())
        return stripslashes($x);
    return $x;
}

function mksecret($len = 20) {
    $ret = "";
    for ($i = 0; $i < $len; $i++)
        $ret .= chr(mt_rand(0, 255));
    return $ret;
}


function logincookie($id, $passhash, $expires = 0x7fffffff)
{
    setcookie("uid", $id, $expires, "/");
    setcookie("pass", $passhash, $expires, "/");

}

function logoutcookie() {
    setcookie("uid", "", 0x7fffffff, "/");
    setcookie("pass", "", 0x7fffffff, "/");
}

function hash_pad($hash) {
    return str_pad($hash, 20);
}

/**** validip/getip courtesy of manolete <manolete@myway.com> ****/

// IP Validation
function validip($ip)
{
    if (!empty($ip) && ip2long($ip)!=-1)
    {
        // reserved IANA IPv4 addresses
        // http://www.iana.org/assignments/ipv4-address-space
        $reserved_ips = array (
                array('0.0.0.0','2.255.255.255'),
                array('10.0.0.0','10.255.255.255'),
                array('127.0.0.0','127.255.255.255'),
                array('169.254.0.0','169.254.255.255'),
                array('172.16.0.0','172.31.255.255'),
                array('192.0.2.0','192.0.2.255'),
                array('192.168.0.0','192.168.255.255'),
                array('255.255.255.0','255.255.255.255')
        );

        foreach ($reserved_ips as $r)
        {
                $min = ip2long($r[0]);
                $max = ip2long($r[1]);
                if ((ip2long($ip) >= $min) && (ip2long($ip) <= $max)) return false;
        }
        return true;
    }
    else return false;
}

// Patched function to detect REAL IP address if it's valid
function getip()
{
    global $HTTP_SERVER_VARS;
    if (validip($HTTP_SERVER_VARS['HTTP_CLIENT_IP'])) return $HTTP_SERVER_VARS['HTTP_CLIENT_IP'];
    elseif ($HTTP_SERVER_VARS['HTTP_X_FORWARDED_FOR']!="")
    {
        $forwarded=str_replace(",","",$HTTP_SERVER_VARS['HTTP_X_FORWARDED_FOR']);
        $forwarded_array=split(" ",$forwarded);
        foreach($forwarded_array as $value)    if (validip($value)) return $value;
    }
    return $HTTP_SERVER_VARS['REMOTE_ADDR'];
}


function userlogin() {
    global $CURUSER;
    unset($GLOBALS["CURUSER"]);


    $ip = getip(); //$_SERVER["REMOTE_ADDR"];
    $nip = ip2long($ip);
    $res = mysql_query("SELECT * FROM bannedip WHERE $nip >= first AND $nip <= last") or sqlerr(__FILE__, __LINE__);
    if (mysql_num_rows($res) > 0)
    {
      header("HTTP/1.0 403 Forbidden");
      print("<html><body><h1>403 Forbidden</h1>Unauthorized IP address.</body></html>\n");
      die;
    }



    // guest
    if (empty($_COOKIE["uid"]) || empty($_COOKIE["pass"]))
       $id=1;
//        return;


    $id = 0 + $_COOKIE["uid"];
    // it's guest
    if (!$id)
       $id=1;
//        return;


    $res = mysql_query("SELECT users.topicsperpage, users.postsperpage,users.torrentsperpage, users.flag, users.avatar, UNIX_TIMESTAMP(users.lastconnect) AS lastconnect, UNIX_TIMESTAMP(users.joined) AS joined, users.id as uid, users.username, users.password, users.random, users.email, users.language,users.style, users_level.* FROM users INNER JOIN users_level ON users.id_level=users_level.id WHERE users.id = $id") or die(mysql_error());
    $row = mysql_fetch_array($res);
    if (!$row)
       {
       $id=1;
       $res = mysql_query("SELECT users.topicsperpage, users.postsperpage,users.torrentsperpage, users.flag, users.avatar, UNIX_TIMESTAMP(users.lastconnect) AS lastconnect, UNIX_TIMESTAMP(users.joined) AS joined, users.id as uid, users.username, users.password, users.random, users.email, users.language,users.style, users_level.* FROM users INNER JOIN users_level ON users.id_level=users_level.id WHERE users.id = 1");
       $row = mysql_fetch_array($res);
       }
    if (($_COOKIE["pass"] != $row["password"]) && $id != 1)
       {
       $id=1;
       $res = mysql_query("SELECT users.topicsperpage, users.postsperpage,users.torrentsperpage, users.flag, users.avatar, UNIX_TIMESTAMP(users.lastconnect) AS lastconnect, UNIX_TIMESTAMP(users.joined) AS joined, users.id as uid, users.username, users.password, users.random, users.email, users.language,users.style, users_level.* FROM users INNER JOIN users_level ON users.id_level=users_level.id WHERE users.id = 1");
       $row = mysql_fetch_array($res);
       }

    //$ip=$_SERVER["REMOTE_ADDR"]);
    $ip=sprintf("%u", ip2long($_SERVER["REMOTE_ADDR"]));
    if ($id>1)
       mysql_query("UPDATE users SET lastconnect=NOW(), lip=".$ip." WHERE users.id = $id");
    else
        mysql_query("UPDATE users SET lastconnect=NOW(), lip=0 WHERE users.id = 1");
    $GLOBALS["CURUSER"] = $row;
    unset($row);

}

function dbconn($do_clean=false) {
    global $dbhost, $dbuser, $dbpass, $database, $HTTP_SERVER_VARS;

    if ($GLOBALS["persist"])
        $conres=mysql_pconnect($dbhost, $dbuser, $dbpass);
    else
        $conres=mysql_connect($dbhost, $dbuser, $dbpass);

    if (!$conres)
    {
      switch (mysql_errno())
      {
        case 1040:
        case 2002:
            if ($HTTP_SERVER_VARS[REQUEST_METHOD] == "GET")
                die("<html><head><meta http-equiv=refresh content=\"20 $HTTP_SERVER_VARS[REQUEST_URI]\"></head><body><table border=0 width=100% height=100%><tr><td><h3 align=center>The server load is very high at the moment. Retrying, please wait...</h3></td></tr></table></body></html>");
            else
                die("Too many users. Please press the Refresh button in your browser to retry.");
        default:
            die("[" . mysql_errno() . "] dbconn: mysql_connect: " . mysql_error());
      }
    }
    mysql_select_db($database)
        or die("Can't open database $database - ".mysql_error());

    userlogin();


    if ($do_clean)
       register_shutdown_function("cleandata");
}

function cleandata() {

    require_once("sanity.php");

    global $clean_interval;

    if ((0+$clean_interval)==0)
       return;

    $now = time();

    $res = mysql_query("SELECT last_time FROM tasks WHERE task='sanity'");
    $row = mysql_fetch_array($res);
    if (!$row) {
        mysql_query("INSERT INTO tasks (task, last_time) VALUES ('sanity',$now)");
        return;
    }
    $ts = $row[0];
    if ($ts + $clean_interval > $now)
        return;
    mysql_query("UPDATE tasks SET last_time=$now WHERE task='sanity' AND last_time = $ts");
    if (!mysql_affected_rows())
        return;

    do_sanity();

}

function updatedata() {

    require_once("getscrape.php");

    global $update_interval;

    if ((0+$update_interval)==0)
       return;

    $now = time();


    $res = @mysql_query("SELECT last_time FROM tasks WHERE task='update'");
    $row = @mysql_fetch_array($res);
    if (!$row) {
        mysql_query("INSERT INTO tasks (task, last_time) VALUES ('update',$now)");
//die("INSERT INTO tasks (task, last_time) VALUES ('update',$now)");
        return;
    }
    $ts = $row[0];
    if ($ts + $update_interval > $now)
        return;


    mysql_query("UPDATE tasks SET last_time=$now WHERE task='update' AND last_time = $ts");
    if (!mysql_affected_rows())
        return;

    $res = mysql_query("SELECT * FROM namemap WHERE external='yes' ORDER BY lastupdate ASC");
    if (!$res)
       return;
    $row = mysql_fetch_array($res);

    scrape($row["announce_url"],$row["info_hash"]);


}

function pager($rpp, $count, $href, $opts = array()) {

    $pages = ceil($count / $rpp);

    if (!$opts["lastpagedefault"])
        $pagedefault = 0;
    else {
        $pagedefault = floor(($count - 1) / $rpp);
        if ($pagedefault < 0)
            $pagedefault = 0;
    }

    if (isset($_GET["page"])) {
        $page = 0 + $_GET["page"];
        if ($page < 0)
            $page = $pagedefault;
    }
    else
        $page = $pagedefault;


    $pager = "";

    $mp = $pages - 1;
    $as = "<b>&lt;&lt;&nbsp;".PREVIOUS."</b>";
    if ($page >= 1) {
        $pager .= "<a href=\"{$href}page=" . ($page - 1) . "\">";
        $pager .= $as;
        $pager .= "</a>";
    }
    else
        $pager .= $as;

    $pager .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";

    $as = "<b>".NEXT."&nbsp;&gt;&gt;</b>";

    if ($page < $mp && $mp >= 0) {
        $pager .= "<a href=\"{$href}page=" . ($page + 1) . "\">";
        $pager .= $as;
        $pager .= "</a>";
    }
    else
        $pager .= $as;


    if ($count) {
        $pagerarr = array();
        $dotted = 0;
        $dotspace = 3;
        $dotend = $pages - $dotspace;
        $curdotend = $page - $dotspace;
        $curdotstart = $page + $dotspace;
        for ($i = 0; $i < $pages; $i++) {
            if (($i >= $dotspace && $i <= $curdotend) || ($i >= $curdotstart && $i < $dotend)) {
                if (!$dotted)
                    $pagerarr[] = "...";
                $dotted = 1;
                continue;
            }
            $dotted = 0;
            $start = $i * $rpp + 1;
            $end = $start + $rpp - 1;
            if ($end > $count)
                $end = $count;

            $text = "$start&nbsp;-&nbsp;$end";
            if ($i != $page)
                $pagerarr[] = "<a href=\"{$href}page=$i\">$text</a>";
            else
                $pagerarr[] = "<b>$text</b>";
        }

        $pagerstr = join(" | ", $pagerarr);
        $pagertop = "<p align=\"center\">$pager<br />$pagerstr</p>\n";
        $pagerbottom = "<p align=\"center\">$pagerstr<br />$pager</p>\n";
    }
    else {
        $pagertop = "<p align=\"center\">$pager</p>\n";
        $pagerbottom = $pagertop;
    }

    $start = $page * $rpp;
    return array($pagertop, $pagerbottom, "LIMIT $start,$rpp");

}

// give back categories recorset
function genrelist() {

    $ret = array();
    $res = mysql_query("SELECT * FROM categories ORDER BY sort_index, id");

    while ($row = mysql_fetch_array($res))
        $ret[] = $row;

    return $ret;

}
function style_list()
         {

         $ret = array();
         $res = mysql_query("SELECT * FROM style ORDER BY id");

         while ($row = mysql_fetch_array($res))
             $ret[] = $row;

         return $ret;

}

function language_list()
         {

         $ret = array();
         $res = mysql_query("SELECT * FROM language ORDER BY language");

         while ($row = mysql_fetch_array($res))
             $ret[] = $row;

         return $ret;

}

function flag_list()
{
  $ret = array();
    $res = mysql_query("SELECT * FROM countries ORDER BY name");

    while ($row = mysql_fetch_array($res))
      $ret[] = $row;

    return $ret;
}

function stdfoot() {

    global $STYLEPATH;

    include($STYLEPATH."/footer.php");

    print_version();
    print("</body>\n</html>\n");

    register_shutdown_function("updatedata");

}



function linkcolor($num) {

    if (!$num)
        return "red";
    if ($num == 1)
        return "yellow";

    return "green";
}


function format_quote($text)
{
  $string=$text;
  $prev_string = "";
  while ($prev_string != $string)
        {
    $prev_string = $string;
    $string = preg_replace("/\[quote\]\s*((\s|.)+?)\s*\[\/quote\]\s*/i", "<b>Quote:</b><br /><table width=100% class=main border=1 cellspacing=0 cellpadding=10><tr><td style='border: 1px black solid'>\\1</td></tr></table><br />", $string);
    $string = preg_replace("/\[quote=(.+?)\]\s*((\s|.)+?)\s*\[\/quote\]\s*/i", "<b>\${1} wrote:</b><br /><table width=100% class=main border=1 cellspacing=0 cellpadding=10><tr><td style='border: 1px black solid'>\\2</td></tr></table><br />", $string);
  }

return $string;
}

function format_comment($text, $strip_html = true)
{
    global $smilies, $privatesmilies, $BASEURL;

    $s = $text;

    if ($strip_html)
        $s = htmlspecialchars($s);

    $s = unesc($s);

    $f=@fopen("badwords.txt","r");
    if ($f)
       {
       $bw=fread($f,filesize("badwords.txt"));
       $badwords=explode("\n",$bw);
       for ($i=0;$i<count($badwords);++$i)
           $badwords[$i]=trim($badwords[$i]);
       $s = str_replace($badwords,"*censured*",$s);
       }
    @fclose($f);

    // [*]
    $s = preg_replace("/\[\*\]/", "<li>", $s);

    // [b]Bold[/b]
    $s = preg_replace("/\[b\]((\s|.)+?)\[\/b\]/", "<b>\\1</b>", $s);

    // [i]Italic[/i]
    $s = preg_replace("/\[i\]((\s|.)+?)\[\/i\]/", "<i>\\1</i>", $s);

    // [u]Underline[/u]
    $s = preg_replace("/\[u\]((\s|.)+?)\[\/u\]/", "<u>\\1</u>", $s);

    // [u]Underline[/u]
    $s = preg_replace("/\[u\]((\s|.)+?)\[\/u\]/i", "<u>\\1</u>", $s);

    // [img]http://www/image.gif[/img]
    $s = preg_replace("/\[img\](http:\/\/[^\s'\"<>]+(\.gif|\.jpg|\.png))\[\/img\]/", "<img border=0 src=\"\\1\">", $s);

    // [img=http://www/image.gif]
    $s = preg_replace("/\[img=(http:\/\/[^\s'\"<>]+(\.gif|\.jpg|\.png))\]/", "<img border=0 src=\"\\1\">", $s);

    // [color=blue]Text[/color]
    $s = preg_replace(
        "/\[color=([a-zA-Z]+)\]((\s|.)+?)\[\/color\]/i",
        "<font color=\\1>\\2</font>", $s);

    // [color=#ffcc99]Text[/color]
    $s = preg_replace(
        "/\[color=(#[a-f0-9][a-f0-9][a-f0-9][a-f0-9][a-f0-9][a-f0-9])\]((\s|.)+?)\[\/color\]/i",
        "<font color=\\1>\\2</font>", $s);

    // [url=http://www.example.com]Text[/url]
    $s = preg_replace(
        "/\[url=((http|ftp|https|ftps|irc):\/\/[^<>\s]+?)\]((\s|.)+?)\[\/url\]/i",
        "<a href=\\1 target=_blank>\\3</a>", $s);

    // [url]http://www.example.com[/url]
    $s = preg_replace(
        "/\[url\]((http|ftp|https|ftps|irc):\/\/[^<>\s]+?)\[\/url\]/i",
        "<a href=\\1 target=_blank>\\1</a>", $s);

    // [size=4]Text[/size]
    $s = preg_replace(
        "/\[size=([1-7])\]((\s|.)+?)\[\/size\]/i",
        "<font size=\\1>\\2</font>", $s);

    // [font=Arial]Text[/font]
    $s = preg_replace(
        "/\[font=([a-zA-Z ,]+)\]((\s|.)+?)\[\/font\]/i",
        "<font face=\"\\1\">\\2</font>", $s);


    //[quote]Text[/quote]
//    $s = preg_replace(
//        "/\[quote\]\s*((\s|.)+?)\s*\[\/quote\]\s*/i",
//        "<b>Quote:</b><br /><table width=100% class=main border=1 cellspacing=0 cellpadding=10><tr><td style='border: 1px black solid'>\\1</td></tr></table><br />", $s);

    //[quote=Author]Text[/quote]
//    $s = preg_replace(
//        "/\[quote=(.+?)\]\s*((\s|.)+?)\s*\[\/quote\]\s*/i",
//        "<b>\\1 wrote:</b><br /><table width=100% class=main border=1 cellspacing=0 cellpadding=10><tr><td style='border: 1px black solid'>\\2</td></tr></table><br />", $s);

    $s=format_quote($s);

    // URLs
    //$s = preg_replace( "/(?<!<a href=\")((http|ftp)+(s)?:\/\/[^<>\s]+)/i", "<a href=\"\\0\">\\0</a>", $s );

    // Linebreaks
    $s = nl2br($s);

    // Maintain spacing
    $s = str_replace("  ", " &nbsp;", $s);

    reset($smilies);
    while (list($code, $url) = each($smilies))
        $s = str_replace($code, "<img border=0 src=$BASEURL/images/smilies/$url>", $s);

    reset($privatesmilies);
    while (list($code, $url) = each($privatesmilies))
        $s = str_replace($code, "<img border=0 src=$BASEURL/images/smilies/$url>", $s);

    return $s;
}

function image_or_link($image,$style="",$link="")
{
  if ($image=="")
      return $link;
  elseif (file_exists($image))
     return "<img src=$image border=0 $style alt=\"$link\"/>";
  else
      return $link;
}


function standardheader($title = "",$normalpage=true,$idlang=0) {

    global $CURUSER, $SITENAME, $STYLEPATH, $USERLANG;

    // default settings for blocks/menu
    if (!isset($GLOBALS["mainmenu"]))
        $GLOBALS["mainmenu"] = true;
    if (!isset($GLOBALS["usertoolbar"]))
       $GLOBALS["usertoolbar"] = true;
    if (!isset($GLOBALS["trackertoolbar"]))
       $GLOBALS["trackertoolbar"] = true;
    if (!isset($GLOBALS["sidemenu"]))
       $GLOBALS["sidemenu"] = true;
    if (!isset($GLOBALS["userinfo"]))
       $GLOBALS["userinfo"] = true;
    if (!isset($GLOBALS["trackerinfo"]))
       $GLOBALS["trackerinfo"] = true;
    if (!isset($GLOBALS["clockblock"]))
       $GLOBALS["clockblock"] = true;
    if (!isset($GLOBALS["onlineblock"]))
       $GLOBALS["onlineblock"] = true;

    header("Content-Type: text/html; charset=iso-8859-1");

    if ($title == "")
        $title = unesc($SITENAME);
    else
        $title = unesc($SITENAME) . " - " . htmlspecialchars($title);

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "DTD/xhtml1-strict.dtd">
<html><head>
<title><?= $title ?></title>
<?
// get user's style
$resheet=mysql_query("SELECT * FROM style where id=".$CURUSER["style"]."");
if (!$resheet)
   {

   $STYLEPATH="./style/base";
   $style="./style/base/torrent.css";
   }
else
    {
        $resstyle=mysql_fetch_array($resheet);
        $STYLEPATH=$resstyle["style_url"];
        $style=$resstyle["style_url"]."/torrent.css";
    }
print("<link rel=\"stylesheet\" href=$style type=\"text/css\" />");
?>
</head>
<body>
<?

// getting user language
if ($idlang==0)
   $reslang=mysql_query("SELECT * FROM language WHERE id=".$CURUSER["language"]);
else
   $reslang=mysql_query("SELECT * FROM language WHERE id=$idlang");

if (!$reslang)
   {
   $USERLANG="./language/english.txt";
   }
else
    {
        $rlang=mysql_fetch_array($reslang);
        $USERLANG="./".$rlang["language_url"];
    }
require_once($USERLANG);

if ($normalpage)
   require_once($STYLEPATH."/header.php");

}

function err_msg($string,$heading="Error!")
{
  print("<div align=\"center\"><br /><table border=\"0\" width=\"500\" cellspacing=\"0\" cellpadding=\"0\"><tr>\n");
  print("<td bgcolor=\"#FFFFFF\" align=\"center\" style=\"border-style: dotted; border-width: 1px\" bordercolor=\"#CC0000\">\n");
  print("<font color=\"#CC0000\"><b>$heading</b></font><br />$string<br /></td>\n");
  print("</tr></table></div><br />\n");
  print("<center><a href=javascript:history.go(-1)>Back</a></center>");
}

function sqlesc($x) {
    return "'".mysql_escape_string($x)."'";
}

function print_news($limit=0)
         {

         global $CURUSER;

         $model="<table cellpadding='4' cellspacing='1' border='0' width='100%' bgcolor='#000000' style='font-family:Verdana;font-size:11px'>"
             ."\n{admin_menu}"
             ."\n<tr><td class=header>".POSTED_BY.": {user_name}"
             ."\n<br>".POSTED_DATE.": {news_date}"
             ."\n</td></tr><tr><td class=lista align=\"left\">"
             ."\n<b>".TITLE.": {news_title}</b><br><br>"
             ."\n<table style='border-top:1px solid gray;width:100%;font-family:Verdana;font-size:10px'>"
             ."\n<tr><td>{news}</td></tr>"
             ."\n</table></td></tr></table><br>";
         if ($limit>0)
            $limitqry="LIMIT $limit";
         $res=mysql_query("select news.id, news.title,news.news,UNIX_TIMESTAMP(news.date) as news_date,users.username from news inner join users on users.id=news.user_id ORDER BY date DESC $limitqry ");
         while ($rows=mysql_fetch_array($res))
               {
               if ($CURUSER["edit_news"]=="yes" || $CURUSER["delete_news"]=="yes")
                  $adm_menu="<tr><td class=header>";
               if ($CURUSER["edit_news"]=="yes")
                  $adm_menu.="<a href=news.php>".ADD."</a>&nbsp;&nbsp;&nbsp;<a href=news.php?act=edit&id=".$rows["id"].">".EDIT."</a>";
               if ($CURUSER["delete_news"]=="yes")
                  $adm_menu.="&nbsp;&nbsp;&nbsp;<a onclick=\"return confirm('". str_replace("'","\'",DELETE_CONFIRM)."')\" href=news.php?act=del&id=".$rows["id"].">".DELETE."</a></td></tr>";

               $news=format_comment($rows["news"]);
               $output = eregi_replace("{user_name}", unesc($rows["username"]), $model);
               $output = eregi_replace("{admin_menu}", $adm_menu, $output);
               $output = eregi_replace("{news_date}", date("d/m/Y H:i",$rows["news_date"]), $output);
               $output = eregi_replace("{news_title}", unesc($rows["title"]), $output);
               $output = eregi_replace("{news}", $news, $output);
               print $output;
               }
               if ($output=="")
                  {
                  print("<center>".NO_NEWS."...<br />");
                  if ($CURUSER["edit_news"]=="yes")
                     print("<br /><a href=news.php><img border=0 alt=\"".ADD."\" src=\"images/new.gif\"></a><br /></center>");
                  }
}


function block_begin($title="-",$colspan=1) {
    print("<br /><table class=lista cellpadding=0 cellspacing=0 width=95% align=center>\n"
        ."\t<tr>\n"
        ."\t\t<TD class=block align=center height=20px colspan=$colspan><b>$title</b></TD>\n"
        ."\t</tr>\n"
        ."\t<tr>\n"
        ."\t\t<TD width=100% align=justify valign=top>");

}

function block_end($colspan=1) {
    print("\t\t</td>\n"
        ."\t</tr>\n"
        ."\t<tr>\n"
        ."\t\t<TD class=block colspan=$colspan align=center height=20px></TD>\n"
        ."\t</tr>\n"
        ."</table>");
}


function print_users()
         {
         global $CURUSER, $STYLEPATH;

         $search=$_GET["searchtext"];
         $addparams="";
         if ($search!="")
            {
            $where=" AND users.username LIKE '%$search%'";
            $addparams="searchtext=$search";
            }
         else
             $where="";

         $level=intval(0+$_GET["level"]);
         if ($level>0)
            {
            $where.=" AND users.id_level=$level";
            if ($addparams!="")
               $addparams.="&level=$level";
            else
                $addparams="level=$level";
            }

         if ($addparams!="")
            $addparams.="&";

         $res=mysql_query("select COUNT(*) FROM users INNER JOIN users_level ON users.id_level=users_level.id WHERE users.id>1 $where") or die(mysql_error());
         $row = mysql_fetch_row($res);
         $count = $row[0];
         list($pagertop, $pagerbottom, $limit) = pager(20, $count,  "users.php?".$addparams);
         ?>
         <div align=center>
         <form action="users.php" name="ricerca" method="get">
           <table border="0" class=lista>
           <tr>
           <td class=block><? echo FIND_USER; ?> </td>
           <td class=block><? echo USER_LEVEL; ?> </td>
           <td class=block>&nbsp;</td>
           </tr>
           <tr>
           <td><input type="text" name="searchtext" size="30" maxlength="50" value="<? echo $search ?>" /></td>
           <?
           print("<td><select name=\"level\">");
           print("<option value=0".($level==0 ? " selected=selected " : "").">".ALL."</option>");
           $res=mysql_query("SELECT id,level FROM users_level WHERE id_level>1 ORDER BY id_level");
           while($row=mysql_fetch_array($res))
           {
               $select="<option value='".$row["id"]."'";
               if ($level==$row["id"])
                  $select.="selected=\"selected\"";
               $select.=">".$row["level"]."</option>\n";
               print $select;
           }
           print("</select></td>");
           ?>
           </td>
           <td><input type="submit" value="<? echo SEARCH; ?>" /></td>
           </tr>
           </table>
         </form>
         <? print $pagertop; ?>
         <table class=lista width=95%>
         <tr>
         <td class=header align=center><?echo USER_NAME;?></td>
         <td class=header align=center><?echo USER_LEVEL;?></td>
         <td class=header align=center><?echo USER_JOINED;?></td>
         <td class=header align=center><?echo USER_LASTACCESS;?></td>
         <td class=header align=center><?echo PEER_COUNTRY;?></td>
         <td class=header align=center><?echo RATIO;?></td>
         <td class=header align=center>&nbsp;</td>
         <?
             if ($CURUSER["edit_users"]=="yes")
                print("<td class=header align=center>&nbsp;</td>");
             if ($CURUSER["delete_users"]=="yes")
                print("<td class=header align=center>&nbsp;</td>");
         ?>

         </tr>
         <?
         //$query="select users.id, downloaded,uploaded, username,level,UNIX_TIMESTAMP(joined) AS joined,UNIX_TIMESTAMP(lastconnect) AS lastconnect FROM users INNER JOIN users_level ON users.id_level=users_level.id WHERE users.id>1 $where ORDER BY users.id ASC $limit";
         // flag hack
         $query="select prefixcolor, suffixcolor, users.id, downloaded,uploaded, username,level,UNIX_TIMESTAMP(joined) AS joined,UNIX_TIMESTAMP(lastconnect) AS lastconnect, flag, flagpic, name FROM users INNER JOIN users_level ON users.id_level=users_level.id LEFT JOIN countries ON users.flag=countries.id WHERE users.id>1 $where ORDER BY users.id ASC $limit";
         //print($query);
         $rusers=mysql_query($query);
         if (mysql_num_rows($rusers)==0)
            // flag hack
            print("<tr><td class=lista colspan=6>no users found!</td></tr>");
            //print("<tr><td class=lista colspan=5>no users found!</td></tr>");
         else
             {
                 while ($row_user=mysql_fetch_array($rusers))
                       {
                       print("<tr>\n");
                       print("<td class=lista><a href=userdetails.php?id=$row_user[id]>".unesc($row_user["prefixcolor"]).unesc($row_user["username"]).unesc($row_user["suffixcolor"])."</a></td>");
                       print("<td class=lista align=center>".$row_user["level"]."</td>");
                       print("<td class=lista align=center>".($row_user["joined"]==0 ? "N/A" : date("d/m/Y H:i:s",$row_user["joined"]))."</td>");
                       print("<td class=lista align=center>".($row_user["lastconnect"]==0 ? "N/A" : date("d/m/Y H:i:s",$row_user["lastconnect"]))."</td>");
                       print("<td class=lista align=center>". ( $row_user["flag"] == 0 ? "<img src='images/flag/unknow.gif' alt='unknown' title='unknown' />" : "<img src='images/flag/" . $row_user['flagpic'] . "' alt='" . $row_user['name'] . "' title='" . $row_user['name'] . "' />")."</td>");
                       //user ratio
                       if (max(0,$row_user["downloaded"])>0)
                          $ratio=number_format($row_user["uploaded"]/$row_user["downloaded"],2);
                       else
                           $ratio="oo";
                       print("<td class=lista align=center>$ratio</td>");
                       print("<td class=lista align=center><a href=usercp.php?do=pm&action=edit&uid=$CURUSER[uid]&what=new&to=".urlencode(unesc($row_user["username"])).">".image_or_link("$STYLEPATH/pm.png","","PM")."</a></td>");
                       if ($CURUSER["edit_users"]=="yes")
                          print("<td class=lista align=center><a href=account.php?act=mod&uid=".$row_user["id"]."&returnto=".urlencode("users.php").">".image_or_link("$STYLEPATH/edit.png","",EDIT)."</a></td>");
                       if ($CURUSER["delete_users"]=="yes")
                          print("<td class=lista align=center><a  onclick=\"return confirm('".AddSlashes(DELETE_CONFIRM)."')\" href=account.php?act=del&uid=".$row_user["id"]."&returnto=".urlencode("users.php").">".image_or_link("$STYLEPATH/delete.png","",DELETE)."</a></td>");
                       print("</tr>\n");
                       }
             }
         print("</table>\n</div>\n<br />");


}


function makesize($bytes) {
  if ($bytes < 1000 * 1024)
    return number_format($bytes / 1024, 2) . " KB";
  if ($bytes < 1000 * 1048576)
    return number_format($bytes / 1048576, 2) . " MB";
  if ($bytes < 1000 * 1073741824)
    return number_format($bytes / 1073741824, 2) . " GB";
  return number_format($bytes / 1099511627776, 2) . " TB";
}


function redirect($redirecturl) {
// using javascript for redirecting
// some hosting has warning enabled and this is causing
// problem withs header() redirecting...

        print(REDIRECT." <a href=\"$redirecturl\">".HERE."</a>");
        print("<script LANGUAGE=\"javascript\">window.location.href=\"$redirecturl\"</script>");

}

function textbbcode($form,$name,$content="") {
?>

<script language=javascript>
function SmileIT(smile,form,text){
    document.forms[form].elements[text].value = document.forms[form].elements[text].value+" "+smile+" ";
    document.forms[form].elements[text].focus();
}

function PopMoreSmiles(form,name) {
         link='moresmiles.php?form='+form+'&text='+name
         newWin=window.open(link,'moresmile','height=500,width=300,resizable=yes,scrollbars=yes');
         if (window.focus) {newWin.focus()}
}

function BBTag(tag,s,text,form){
switch(tag)
    {
    case '[quote]':
    if (document.forms[form].elements[s].value=="QUOTE ")
       {
        document.forms[form].elements[text].value = document.forms[form].elements[text].value+"[quote]";
        document.forms[form].elements[s].value="QUOTE*";
        }
       else
           {
           document.forms[form].elements[text].value = document.forms[form].elements[text].value+"[/quote]";
           document.forms[form].elements[s].value="QUOTE ";
           }
        break;
    case '[img]':
    if (document.forms[form].elements[s].value=="IMG ")
       {
        document.forms[form].elements[text].value = document.forms[form].elements[text].value+"[img]";
        document.forms[form].elements[s].value="IMG*";
        }
       else
           {
           document.forms[form].elements[text].value = document.forms[form].elements[text].value+"[/img]";
           document.forms[form].elements[s].value="IMG ";
           }
        break;
    case '[url]':
    if (document.forms[form].elements[s].value=="URL ")
       {
        document.forms[form].elements[text].value = document.forms[form].elements[text].value+"[url]";
        document.forms[form].elements[s].value="URL*";
        }
       else
           {
           document.forms[form].elements[text].value = document.forms[form].elements[text].value+"[/url]";
           document.forms[form].elements[s].value="URL ";
           }
        break;
    case '[*]':
    if (document.forms[form].elements[s].value=="List ")
       {
        document.forms[form].elements[text].value = document.forms[form].elements[text].value+"[*]";
        }
        break;
    case '[b]':
    if (document.forms[form].elements[s].value=="B ")
       {
        document.forms[form].elements[text].value = document.forms[form].elements[text].value+"[b]";
        document.forms[form].elements[s].value="B*";
        }
       else
           {
           document.forms[form].elements[text].value = document.forms[form].elements[text].value+"[/b]";
           document.forms[form].elements[s].value="B ";
           }
        break;
    case '[i]':
    if (document.forms[form].elements[s].value=="I ")
       {
        document.forms[form].elements[text].value = document.forms[form].elements[text].value+"[i]";
        document.forms[form].elements[s].value="I*";
        }
       else
           {
           document.forms[form].elements[text].value = document.forms[form].elements[text].value+"[/i]";
           document.forms[form].elements[s].value="I ";
           }
        break;
    case '[u]':
    if (document.forms[form].elements[s].value=="U ")
       {
        document.forms[form].elements[text].value = document.forms[form].elements[text].value+"[u]";
        document.forms[form].elements[s].value="U*";
        }
       else
           {
           document.forms[form].elements[text].value = document.forms[form].elements[text].value+"[/u]";
           document.forms[form].elements[s].value="U ";
           }
        break;
    }
    document.forms[form].elements[text].focus();
}

</script>

  <table width="100%" cellpadding="0" cellspacing="0">
    <tr>
      <td colspan=2>
      <table cellpadding="0" cellspacing="1">
      <tr>
      <td><input style="font-weight: bold;" type="button" name="bold" value="B " onclick="javascript: BBTag('[b]','bold','<? echo $name; ?>','<? echo $form; ?>')" /></td>
      <td><input style="font-style: italic;" type="button" name="italic" value="I " onclick="javascript: BBTag('[i]','italic','<? echo $name; ?>','<? echo $form; ?>')" /></td>
      <td><input style="text-decoration: underline;" type="button" name="underline" value="U " onclick="javascript: BBTag('[u]','underline','<? echo $name; ?>','<? echo $form; ?>')" /></td>
      <td><input type="button" name="li" value="List " onclick="javascript: BBTag('[*]','li','<? echo $name; ?>','<? echo $form; ?>')" /></td>
      <td><input type="button" name="quote" value="QUOTE " onclick="javascript: BBTag('[quote]','quote','<? echo $name; ?>','<? echo $form; ?>')" /></td>
      <td><input type="button" name="url" value="URL " onclick="javascript: BBTag('[url]','url','<? echo $name; ?>','<? echo $form; ?>')" /></td>
      <td><input type="button" name="img" value="IMG " onclick="javascript: BBTag('[img]','img','<? echo $name; ?>','<? echo $form; ?>')" /></td>
      </tr>
      </table>
      </td>
    </tr>
    <tr>
      <td>
      <textarea name="<? echo $name; ?>" rows="10" cols="40"><? echo $content; ?></textarea>
      </td>
      <td>
      <table width="100%" cellpadding="1" cellspacing="1">
      <?

      global $smilies;
      while ((list($code, $url) = each($smilies)) && $count<20) {
         if ($count % 4==0)
            print("<tr>");

            print("\n<td><a href=\"javascript: SmileIT('".str_replace("'","\'",$code)."','$form','$name')\"><img border=0 src=images/smilies/".$url."></a></td>");
            $count++;

         if ($count % 4==0)
            print("</tr>");
      }
      ?>
      </table>
      <center><a href="javascript: PopMoreSmiles('<? echo $form; ?>','<? echo $name; ?>')"><? echo MORE_SMILES;?></a></center>
      </td>
    </tr>
  </table>
<?
}

// begin functions for the forum

function is_valid_id($id)
{
  return is_numeric($id) && ($id > 0) && (floor($id) == $id);
}

function begin_table($fullwidth = false, $padding = 5)
{
  if ($fullwidth)
    $width = " width=100%";
  print("<table class=lista$width border=1 cellspacing=0 cellpadding=$padding>\n");
}

function end_table()
{
  print("</td></tr></table>\n");
}

function begin_frame($caption = "", $center = false, $padding = 10)
{
  if ($caption)
    print("<center><h3>$caption</h3></center>\n");

  if ($center)
    $tdextra .= " align=center";

  print("<table width=100% cellspacing=0 cellpadding=$padding><tr><td$tdextra>\n");

}

function end_frame()
{
  print("</td></tr></table>\n");
}

function get_date_time($timestamp = 0)
{
  if ($timestamp)
    return date("d/m/Y H:i:s", $timestamp);
  else
    return gmdate("d/m/Y H:i:s");
}

function stderr($heading, $text)
{
  //standardheader();
  err_msg($text,$heading);
  stdfoot();
  die;
}
function encodehtml($s, $linebreaks = true)
{
  $s = str_replace("<", "&lt;", str_replace("&", "&amp;", $s));
  if ($linebreaks)
    $s = nl2br($s);
  return $s;
}

function get_elapsed_time($ts)
{
  $mins = floor((time() - $ts) / 60);
  $hours = floor($mins / 60);
  $mins -= $hours * 60;
  $days = floor($hours / 24);
  $hours -= $days * 24;
  $weeks = floor($days / 7);
  $days -= $weeks * 7;
  $t = "";
  if ($weeks > 0)
    return "$weeks week" . ($weeks > 1 ? "s" : "");
  if ($days > 0)
    return "$days day" . ($days > 1 ? "s" : "");
  if ($hours > 0)
    return "$hours hour" . ($hours > 1 ? "s" : "");
  if ($mins > 0)
    return "$mins min" . ($mins > 1 ? "s" : "");
  return "< 1 min";
}

function sql_timestamp_to_unix_timestamp($s)
{
  return mktime(substr($s, 11, 2), substr($s, 14, 2), substr($s, 17, 2), substr($s, 5, 2), substr($s, 8, 2), substr($s, 0, 4));
}

function gmtime()
{
    return strtotime(get_date_time());
}

function sqlerr($file = '', $line = '')
{
  print("<table border=0 bgcolor=blue align=left cellspacing=0 cellpadding=10 style='background: blue'>" .
    "<tr><td class=embedded><font color=white><h1>SQL Error</h1>\n" .
  "<b>" . mysql_error() . ($file != '' && $line != '' ? "<p>in $file, line $line</p>" : "") . "</b></font></td></tr></table>");
  die;
}

function attach_frame($padding = 10)
{
  print("</td></tr><tr><td style='border-top: 0px'>\n");
}

function httperr($code = 404) {
    header("HTTP/1.0 404 Not found");
    print("<h1>Not Found</h1>\n");
    print("<p>Sorry...</p>\n");
    exit();
}

// EOF
?>